#ifdef GL_ES
precision highp float;
#endif

#ifdef GL_ES
#ifndef LOWP
#define LOWP lowp
#define MEDIUMP mediump
#define HIGHP highp
#endif
#else
#define LOWP
#define MEDIUMP
#define HIGHP
#endif

attribute vec4 a_vertex;
attribute LOWP vec4 a_color;
attribute MEDIUMP vec2 a_texcoord;

uniform mat4 u_modelview;
varying MEDIUMP vec4 v_color;
varying MEDIUMP vec2 v_texcoord;

void main()
{
	// z stores highlight. We do (a_vertex.z * (1.0/65536.0) + 1.0) here, because otherwise
	// we may get significant artifacts because of z transform, which may
	// happen in the game with SpriteBatch SpriteTransformMode::Auto mode enabled
	MEDIUMP float highlight = a_vertex.z * (1.0/65536.0) + 1.0;
	v_color.rgb = a_color.rgb * highlight;
	v_color.a = a_color.a;
	v_texcoord = a_texcoord;
	
	gl_Position = a_vertex.x * u_modelview[0] + a_vertex.y * u_modelview[1] + u_modelview[3];
}
