#ifdef GL_ES
precision highp float;
#endif

uniform LOWP sampler2D sampler;

#if defined(ENGINE_OS_ANDROID)
	uniform LOWP sampler2D sampler1;
	uniform int CombinedTexture;
#endif

varying vec2 v_texcoord;
varying LOWP vec4 v_color;
uniform LOWP float koef;
uniform LOWP vec4 addColor;

void main()
{
	LOWP vec4 color = texture2D(sampler, v_texcoord);

	gl_FragColor = mix(color, addColor, koef);

#if defined(ENGINE_OS_ANDROID)
	if (CombinedTexture == 1) {
		LOWP float a = texture2D(sampler1, v_texcoord).r;
		gl_FragColor.a = a + koef * smoothstep(0.0, 0.6, a);
	}
	else
#endif
	{
		gl_FragColor.a = color.a + koef * smoothstep(0.0, 0.6, color.a);
	}
}
