attribute vec4 a_vertex;
attribute vec3 a_normal;
attribute vec2 a_texcoord;

uniform mat4 u_modelview;
uniform mat4 u_view;
uniform vec3 light;
uniform float intensity_min;
uniform float intensity_max;

varying float v_density;

varying LOWP vec4 v_color;
varying vec2 v_texcoord;
varying vec3 v_texcoord1;
varying vec3 v_texcoord2;
varying float i;

#define PI 3.14159265359

void main()
{
	float intense = dot(normalize(u_view * vec4(a_normal, 0.0)).xyz, light);
	intense = 0.5 + 0.5 * intense;
	

	gl_Position = u_modelview * a_vertex;
	v_texcoord = a_texcoord;

	v_color = vec4(1.0);
	i =  mix(intensity_min, intensity_max, sin(PI *intense));
}
