#ifdef GL_ES
precision highp float;
#endif

/*
const float A_LIMIT = 0.8;
const float GRAD_EDGE = 0.7;
const float GRAD_MIN = 0.4;

uniform float alpha;
varying vec2 v_texcoord;

void main(void)
{
	vec2 v = v_texcoord - vec2(0.5);
	float len = length(v);
	float p = clamp(len / GRAD_EDGE, 0.0, 1.0);
			
	gl_FragColor.rgb = vec3(0.01, 0.08, 0.17);
	gl_FragColor.a = A_LIMIT * mix(GRAD_MIN, 1.0, p) * alpha; 
}
*/

uniform float alpha;
varying vec2 v_texcoord;

uniform LOWP sampler2D sampler;
#if defined(ENGINE_OS_ANDROID)
	uniform LOWP sampler2D sampler1;
	uniform int CombinedTexture;
#endif

void main(void){
	
	gl_FragColor.rgb = vec3(0.01, 0.08, 0.17);

#if defined(ENGINE_OS_ANDROID)
	if (CombinedTexture == 1){
		gl_FragColor.a = texture2D(sampler1, v_texcoord).r;
	}else
#endif
	{
		gl_FragColor.a = texture2D(sampler, v_texcoord).a;
	}
	
	gl_FragColor.a *= alpha;
}