#ifdef GL_ES
precision highp float;
#endif

uniform LOWP sampler2D sampler;
#if defined(ENGINE_OS_ANDROID)
	uniform LOWP sampler2D sampler1;
	uniform int CombinedTexture;
#endif

uniform float alpha;
uniform float time;
uniform float global_a;

varying vec2 v_texcoord;
varying float wave_x;

const float RED_TRESHOLD = 0.874;
const float YELLOW_INTENSE_05 = 0.45;


void main(void)
{
	LOWP vec4 basePx = texture2D(sampler, v_texcoord);
#if defined(ENGINE_OS_ANDROID)
	if (CombinedTexture == 1){
		basePx.a = texture2D(sampler1, v_texcoord).r ;
	}
#endif

	

	float mask = (sin(wave_x * 12.5 - time * 3.0) * 0.5 + 0.5);
	gl_FragColor.rgb = basePx.rgb;
	gl_FragColor.a   = alpha * global_a;
	gl_FragColor.rgb = mix(gl_FragColor.rgb * mask * 1.5, gl_FragColor.rgb, basePx.r);

}