#ifdef GL_ES
precision highp float;
#endif

uniform LOWP sampler2D sampler;
#if defined(ENGINE_OS_ANDROID)
	uniform LOWP sampler2D sampler1;
	uniform int CombinedTexture;
#endif

uniform float glow;
uniform float global_a;

varying vec2 v_texcoord;

const float RED_TRESHOLD = 0.66;



void main(void)
{
	LOWP vec4 basePx = texture2D(sampler, v_texcoord);
#if defined(ENGINE_OS_ANDROID)
	if (CombinedTexture == 1){
		basePx.a = texture2D(sampler1, v_texcoord).r ;
	}
#endif	
    gl_FragColor.rgb = mix(basePx.rgb, vec3(1.0), 0.95 * glow);
	gl_FragColor.a = basePx.a * global_a;
}