#ifdef GL_ES
precision highp float;
#endif

uniform LOWP sampler2D sampler;
varying vec2 v_texcoord;
varying LOWP vec4 v_color;

uniform LOWP float u_glow_power;
uniform LOWP vec4 u_glow_layer;

// для плавого поджигания и затухания луча
uniform LOWP float u_light_level;

void main()
{
	LOWP vec4 color = texture2D(sampler, v_texcoord);

	color.rgb *= u_glow_layer.rgb;
	MEDIUMP float c = color.r + color.g + color.b;
	gl_FragColor = mix(
		vec4(0.0, 0.0, 0.0, 0.0),
		vec4(1.0, 0.85, 0.25, 1.0),
		c) * u_glow_power * 1.25 * u_light_level;
}