#ifdef GL_ES
precision highp float;
#endif

varying LOWP vec2 v_texcoord;

// рассеянние луча: 0.0 - рассеянный, неплотный, 1.0 - сфокусированный
uniform LOWP float u_scattering;

// для плавого поджигания и затухания луча
uniform LOWP float u_light_level;

void main()
{
	float d = v_texcoord.y;
	float ray_power = d * v_texcoord.x;
	ray_power *= ray_power;
	ray_power *= u_light_level;

	gl_FragColor = vec4(1.0, 0.85, 0.25, 1.0) * ray_power * 1.5 * mix(u_scattering, 1.0, (1.0 - v_texcoord.x));
}
