#ifdef GL_ES
precision highp float;
#endif

uniform LOWP sampler2D sampler;
#if defined(ENGINE_OS_ANDROID)
	uniform LOWP sampler2D sampler1;
	uniform int CombinedTexture;
#endif

varying vec2 v_texcoord;
varying LOWP vec4 v_color;
uniform LOWP float mixCoef;
uniform LOWP vec4 mixColor;
uniform LOWP vec3 inactiveParams;

void main()
{	
	LOWP vec4 color = texture2D(sampler, v_texcoord);
	LOWP float alpha = color.a;
	
	color.rgb = vec3(dot(color.rgb, inactiveParams));
	color.rgb = mix(color.rgb, mixColor.rgb, mixCoef);
	gl_FragColor = smoothstep(0.0, 0.85, color);
	
#if defined(ENGINE_OS_ANDROID)
	if (CombinedTexture == 1) {
		alpha = texture2D(sampler1, v_texcoord).r;
	}
#endif
	gl_FragColor.a = alpha * mixColor.a;
}
