#ifdef GL_ES
precision highp float;
#endif

const int NODES = 4;

varying vec2 v_texcoord;

uniform vec4 colors[NODES];
uniform vec2 alphas[NODES];
uniform float alpha;
uniform float overglow;


void main(void)
{
	vec2 v = v_texcoord - vec2(0.5);
	float len = length(v);
	float p = clamp(len / 0.5, 0.0, 1.0);
	gl_FragColor = vec4(0.0);
	
	for(int i = 0; i < NODES-1; ++i){
		float s = colors[i].a;
		float e = colors[i + 1].a;
		float subp = clamp((p - s) / (e - s), 0.0, 1.0);
		float stp = step(s, p) * step(p, e);
		gl_FragColor.rgb += stp * mix(colors[i].rgb, colors[i + 1].rgb, subp);
		
		s = alphas[i].y;
		e = alphas[i + 1].y;
		subp = clamp((p - s) / (e - s), 0.0, 1.0);
		stp = step(s, p) * step(p, e);
		gl_FragColor.a += stp * mix(alphas[i].x, alphas[i + 1].x, subp);
	}

	float intensity = 1.0 + 0.5 * step(0.95, gl_FragColor.a) * overglow;
	gl_FragColor.rgb *= intensity;
	gl_FragColor.a *= alpha;
}    
