#ifdef GL_ES
precision highp float;
#endif

#define PI 3.14159265358979
const float ABS_OFFSET = 0.2;

varying vec2 v_texcoord;

uniform LOWP sampler2D sampler;

#if defined(ENGINE_OS_ANDROID)
	uniform LOWP sampler2D sampler1;
	uniform int CombinedTexture;
#endif

uniform float p;
uniform float w;


void main(void)
{		
	vec4 basePx = texture2D(sampler, v_texcoord);
#if defined(ENGINE_OS_ANDROID)
	if (CombinedTexture == 1){
		basePx.a = texture2D(sampler1, v_texcoord).r;
	}
#endif

	float a1 = step(p, basePx.g);
	float a2 = step(clamp(0.0,1.0,basePx.g - w), p);
	
	float p1 = 0.7 * p;
	float p2 = p1 - 0.5;
	float a3 = step(p1, basePx.r) * step(basePx.r, p2) * basePx.b;
	
	gl_FragColor.rgb = vec3(1.0,1.0,1.0);
		
	gl_FragColor.a = (sin(p * PI)) *  (a1 * a2 + a3) * basePx.a;
}    
