#ifdef GL_ES
precision highp float;
#endif

varying vec2 v_texcoord;

uniform LOWP sampler2D sampler;
#if defined(ENGINE_OS_ANDROID)
	uniform LOWP sampler2D sampler1;
	uniform int CombinedTexture;
#endif
uniform LOWP sampler2D sampler2;

uniform float alpha;

void main(void)
{
	vec4 basePx = texture2D(sampler, v_texcoord);
	
#if defined(ENGINE_OS_ANDROID)
	if (CombinedTexture == 1){
		basePx.a = texture2D(sampler1, v_texcoord).r;
	}
#endif

	vec3 glowPx = texture2D(sampler2, v_texcoord).rgb;
	

	gl_FragColor.rgb = basePx.rgb + glowPx;
	gl_FragColor.a = basePx.a * alpha;
}