#ifdef GL_ES
#ifndef LOWP
#define LOWP lowp
#define MEDIUMP mediump
#endif

precision highp float;
#endif


uniform LOWP sampler2D sampler;
uniform LOWP sampler2D sampler1;

varying vec2 v_texcoord;

uniform LOWP vec3 light0;
uniform LOWP vec3 light1;
uniform MEDIUMP vec2 light01_pows;

void main()
{
	vec3 distV = texture2D(sampler1, v_texcoord).rgb;

	MEDIUMP vec2 distN = (0.02 * distV.xy - 0.01);

	MEDIUMP float fakeLightingVal = dot(distN.xy, vec2(-50.0,50.0)); // bring it to [-1..1] for more convenient POW parameter 
	                                                                 // (we can also run into precision issues if we operate outside of [-1..1] with POW)

	// clampedLightVals_LightMod.z should be min(distV.z * 2.0, 1.0). Vectorize here for less cycles on some cards!
	MEDIUMP vec3 clampedLightVals_LightMod = max(vec3( fakeLightingVal, -fakeLightingVal, -distV.z * 2.0 ), vec3(0.0, 0.0, -1.0));

	MEDIUMP vec2 fakeLightCoefs = pow( clampedLightVals_LightMod.xy, light01_pows.xy );

	MEDIUMP vec3 lightColor = (fakeLightCoefs.x * light0.rgb + fakeLightCoefs.y * light1.rgb) * -clampedLightVals_LightMod.z;

	gl_FragColor = texture2D(sampler, v_texcoord + distN.xy );
	gl_FragColor.rgb += lightColor;
}
