#ifdef GL_ES
precision highp float;
#endif

uniform LOWP sampler2D sampler;

#if defined(ENGINE_OS_ANDROID)
	uniform LOWP sampler2D sampler1;
	uniform int CombinedTexture;
#endif

varying vec2 v_texcoord;
varying LOWP vec4 v_color;
uniform vec4 addColor;
uniform vec4 gradientColor;

void main()
{
	LOWP vec4 color = texture2D(sampler, v_texcoord) * v_color;
	
	color.b = dot(color.rgb, vec3(0.35, 0.4, 0.17));
	color.b = min(1.0, color.b - 0.05);
	
	MEDIUMP vec4 mixColor = mix(addColor, vec4(gradientColor.rgb, 1.0), 1.0 * pow(1.0 - v_texcoord.y, 5.0));
	MEDIUMP vec4 result = mix(color.bbba, vec4(mixColor.rgb, color.a), 0.45);
	gl_FragColor = 1.2 * result;
}
