attribute vec4 a_vertex;
attribute vec3 a_normal;
attribute vec2 a_texcoord;

uniform mat4 u_modelview;
uniform mat4 u_view;

varying vec2 v_texcoord;
varying vec2 v_texcoord1;

void main()
{
	vec3 cameraUp = vec3(0.0, 0.98, -0.194);
	vec3 cameraRight = vec3(1.0, 0.0, 0.0);

	gl_Position = u_modelview * a_vertex;

#ifndef ENGINE_TARGET_MACOS
	LOWP vec3 viewspaceNormal = normalize(mat3(u_view) * a_normal);
#else
	//GLSL 110 does not allow sub- or super-matrix constructors
	mat3 m = mat3(u_view[0].xyz, u_view[1].xyz, u_view[2].xyz);
	LOWP vec3 viewspaceNormal = normalize(m * a_normal);
#endif

	LOWP float u = dot(cameraUp, viewspaceNormal);
	LOWP float v = dot(cameraRight, viewspaceNormal);

	v_texcoord1 = vec2(v + 1.0, u + 1.0) * 0.5;
	v_texcoord = a_texcoord;
}
