const int MAX_BONES = 80;

attribute vec4 a_vertex;
attribute MEDIUMP vec2 a_texcoord;
attribute vec4 a_weights;
attribute vec4 a_indices;
attribute vec3 a_normal;

uniform mat4 mViewProj;
uniform vec4 mBonesArray[MAX_BONES*3];
uniform vec4 u_lightPos;
uniform vec2 u_fogBorder;

varying MEDIUMP vec2 v_texcoord; // размер текстуры max 256х256
varying LOWP vec4 v_color;

varying float v_density;

void main()
{
	v_texcoord = a_texcoord;
		
	int i = int(a_indices.x) * 3;
	vec3 p = vec3(dot(mBonesArray[i], a_vertex), dot(mBonesArray[i+1], a_vertex), dot(mBonesArray[i+2], a_vertex)) * a_weights.x;

	i = int(a_indices.y) * 3;
	p += vec3(dot(mBonesArray[i], a_vertex), dot(mBonesArray[i+1], a_vertex), dot(mBonesArray[i+2], a_vertex)) * a_weights.y;

	i = int(a_indices.z) * 3;
	p += vec3(dot(mBonesArray[i], a_vertex), dot(mBonesArray[i+1], a_vertex), dot(mBonesArray[i+2], a_vertex)) * a_weights.z;

	i = int(a_indices.w) * 3;
	p += vec3(dot(mBonesArray[i], a_vertex), dot(mBonesArray[i+1], a_vertex), dot(mBonesArray[i+2], a_vertex)) * a_weights.w;

	gl_Position = mViewProj * vec4(p, 1.0);
	
	float d = length(vec4(p, 1.0) - u_lightPos);
	float f = (u_fogBorder.y - d) / (u_fogBorder.y - u_fogBorder.x);
	v_density = (1.0 - clamp(f, 0.0, 1.0)) / 1.3;

	v_color = vec4(1.0);
}
