attribute vec4 a_vertex;
attribute LOWP vec4 a_color;
attribute vec2 a_texcoord;

uniform mat4 u_modelview;

uniform vec4 u_lightPos;
uniform LOWP vec3 u_fogColor;
uniform vec2 u_fogBorder;

varying LOWP vec4 v_color;
varying vec2 v_texcoord;

void main()
{
	float d = length(a_vertex - u_lightPos);
	float f = (u_fogBorder.y - d)/(u_fogBorder.y - u_fogBorder.x);
	float fogK = clamp(f, 0.0, 1.0);
	v_color = mix(u_fogColor, a_color, fogK);
	v_color.a = a_color.a;

	v_texcoord = a_texcoord;
	gl_Position = u_modelview * a_vertex;
}
