#ifdef GL_ES
precision highp float;
#endif

uniform LOWP vec3 u_fogColor;
uniform MEDIUMP float u_density;
uniform LOWP sampler2D sampler;

#if defined(ENGINE_OS_ANDROID)
	uniform LOWP sampler2D sampler1;
	uniform int CombinedTexture;
#endif

varying LOWP vec4 v_color;
varying vec2 v_texcoord;

void main()
{
	LOWP vec4 texColor = v_color * texture2D(sampler, v_texcoord);
	LOWP vec3 color = texColor.rgb;
	
	#if defined(ENGINE_OS_ANDROID)
		if (CombinedTexture == 1) {
			LOWP vec4 alpha = texture2D(sampler1, v_texcoord);
			texColor.a = v_color.a * alpha.r;
		}
	#endif

	color -= (color - u_fogColor) * u_density;
	gl_FragColor = vec4(color, texColor.a);
}