uniform mat4 u_modelview;
uniform mat4 u_model;
uniform float u_posYScale;

attribute vec4 a_vertex;
attribute MEDIUMP vec2 a_texcoord;
attribute LOWP vec4 a_color;

varying MEDIUMP vec2 v_texcoord;
varying vec2 v_causticTexCoord;
varying LOWP vec4 v_color;

void main()
{
	v_color = a_color;
	v_texcoord = a_texcoord;

	vec4 clipPos = u_modelview * a_vertex;
	v_causticTexCoord = clipPos.rg / clipPos.w * u_posYScale * 2.0;
	gl_Position = clipPos;
}
