#ifdef GL_ES
precision highp float;
#endif

varying vec2 v_texcoord;

uniform float p;
uniform float k;
uniform float bs;
uniform float be;
uniform float h1;
uniform float h2;

uniform LOWP sampler2D sampler;
#if defined(ENGINE_OS_ANDROID)
	uniform LOWP sampler2D sampler1;
	uniform int CombinedTexture;
#endif


void main(void)
{
	float y = k * v_texcoord.x + mix(bs, be, p) + mix(-h2, h2, p);
	gl_FragColor.rgb += step(y - h1, v_texcoord.y) * step(v_texcoord.y, y + h1);
	
	float grad = h2 - h1;
	float g1 = clamp((v_texcoord.y - y + h2) / grad,0.0,1.0);
	float g2 = clamp(1.0 - (v_texcoord.y - y - h1) / grad, 0.0,1.0);
	gl_FragColor = texture2D(sampler, v_texcoord);
	
#if defined(ENGINE_OS_ANDROID)
	if (CombinedTexture == 1){
		gl_FragColor.a = texture2D(sampler1, v_texcoord).r;
	}
#endif
	
	gl_FragColor.rgb += min(g1, g2);
}