precision highp float;

varying vec2 v_texcoord;

uniform vec2 pixel;
uniform vec4 uv;

uniform sampler2D sampler;


const float STEP = 2.5;
const float AREA = 25.0;

const vec3 COLOR1 = vec3( 247.0 / 255.0, 241.0/ 255.0, 91.0/255.0);
const vec3 COLOR2 = vec3( 255.0 / 255.0, 152.0/ 255.0, 31.0/255.0);
void main(void)
{
	float alpha = 0.0;
	float num = 0.0;
	for (float  i = -AREA; i <= AREA; i+=STEP){
		for( float j = -AREA; j <= AREA; j+=STEP){
			num += 1.0;
			vec2 curUV = v_texcoord + vec2(i, j)*pixel;
			
			float isTx = step(uv.s, curUV.x) * step(curUV.x, uv.t) * step(uv.p, curUV.y) * step(curUV.y, uv.q);
			alpha += (texture2D(sampler, curUV).a * isTx) ;
		}
	}
	alpha/=num;
	gl_FragColor.rgb = mix (COLOR2, COLOR1, alpha);
	gl_FragColor.a = alpha;
}