const int MAX_BONES = 5;

attribute vec4 a_vertex;
attribute MEDIUMP vec2 a_texcoord;
attribute vec4 a_weights;
attribute vec4 a_indices;
attribute vec3 a_normal;

uniform vec4 mBonesArray[MAX_BONES*3];
uniform mat4 mViewProj;

varying MEDIUMP vec2 v_texcoord; 
varying MEDIUMP vec2 v_capcoord;

void main()
{
	int i = int(a_indices.x) * 3;
	vec3 p = vec3(dot(mBonesArray[i], a_vertex), dot(mBonesArray[i+1], a_vertex), dot(mBonesArray[i+2], a_vertex)) * a_weights.x;
	vec3 n = vec3(dot(mBonesArray[i].xyz, a_normal), dot(mBonesArray[i+1].xyz, a_normal), dot(mBonesArray[i+2].xyz, a_normal)) * a_weights.x;
	if (a_weights.y > 0.0) {
		i = int(a_indices.y) * 3;
		p += vec3(dot(mBonesArray[i], a_vertex), dot(mBonesArray[i+1], a_vertex), dot(mBonesArray[i+2], a_vertex)) * a_weights.y;
		n += vec3(dot(mBonesArray[i].xyz, a_normal), dot(mBonesArray[i+1].xyz, a_normal), dot(mBonesArray[i+2].xyz, a_normal)) * a_weights.y;
	}
	if (a_weights.z > 0.0) {
		i = int(a_indices.z) * 3;
		p += vec3(dot(mBonesArray[i], a_vertex), dot(mBonesArray[i+1], a_vertex), dot(mBonesArray[i+2], a_vertex)) * a_weights.z;
		n += vec3(dot(mBonesArray[i].xyz, a_normal), dot(mBonesArray[i+1].xyz, a_normal), dot(mBonesArray[i+2].xyz, a_normal)) * a_weights.z;
	}
	if (a_weights.w > 0.0) {
		i = int(a_indices.w) * 3;
		p += vec3(dot(mBonesArray[i], a_vertex), dot(mBonesArray[i+1], a_vertex), dot(mBonesArray[i+2], a_vertex)) * a_weights.w;
		n += vec3(dot(mBonesArray[i].xyz, a_normal), dot(mBonesArray[i+1].xyz, a_normal), dot(mBonesArray[i+2].xyz, a_normal)) * a_weights.w;
	}
	gl_Position = mViewProj * vec4(p, 1.0);
		
	v_texcoord = a_texcoord;

	
	
	//LOWP vec3 normal = normalize(mat3(mViewProj[0].xyz, mViewProj[1].xyz, mViewProj[2].xyz) * n);
	LOWP vec3 normal = normalize(n);
	LOWP float u = dot(vec3(0.0, 0.98, -0.194), normal);
	LOWP float v = dot(vec3(1.0, 0.0, 0.0), normal);

	v_capcoord = vec2((v + 1.0), (u + 1.0)) * 0.5;
}