#ifdef GL_ES
precision highp float;
#endif

uniform LOWP sampler2D sampler;
uniform float p;
uniform float l;
uniform float g;
varying vec2 v_texcoord;

//нижний предел градиента по grayscale
const float SW_LOW = 0.275;
//Верхний предел градиента по grayscale const float SW_HI = 0.6;
//SHADOW_W = W_HI - W_LOW
const float SHADOW_W = 0.325;

const float R = 1.0;
const float G = 0.9;
const float B = 0.87;

void main(void)
{
	LOWP vec4 basePx = texture2D(sampler, v_texcoord);
	float grayscale = 0.299 * basePx.r + 0.587 * basePx.g + 0.114 * basePx.b;
	float shadowgrad = clamp((grayscale - SW_LOW)/ SHADOW_W, 0.0, 1.0);
	float xgrad = 1.0 - clamp((abs(v_texcoord.x - p) - l)/abs(g - l), 0.0, 1.0);
	gl_FragColor = basePx;
	gl_FragColor.rgb =  mix(gl_FragColor.rgb, vec3(R,G,B), shadowgrad * xgrad);
}