#ifdef GL_ES
precision highp float;
#endif

uniform LOWP sampler2D sampler;
#if defined(ENGINE_OS_ANDROID)
	uniform LOWP sampler2D sampler1;
	uniform int CombinedTexture;
#endif
uniform float alpha;

varying vec2 v_texcoord;

void main()
{
	gl_FragColor.rgba = texture2D(sampler, v_texcoord);
#if defined(ENGINE_OS_ANDROID)
	if (CombinedTexture == 1) {
		LOWP vec4 comb_alpha = texture2D(sampler1, v_texcoord);
		gl_FragColor.a = comb_alpha.r;
	}
#endif
	gl_FragColor.a *= alpha;
}

/*precision highp float;

uniform LOWP sampler2D sampler;

uniform float time;
uniform vec2 resolution;
varying vec2 v_texcoord;

const vec3 COLOR = vec3( 178.0 / 255.0, 255.0/ 255.0, 238.0/255.0);


vec2 hash( vec2 p )
{
	p = vec2( dot(p,vec2(127.1, 311.7 )),
			  dot(p,vec2(269.5, 183.3 )) );

	return -1.0 + 2.0*fract(sin(p)*(43758.5453123)) + sin(time*0.2);
}


float noise(vec2 p)
{
    vec2 i = floor( p );
    vec2 f = fract( p );
	
	vec2 u = f*f*(3.0-2.0*f);

	
	return mix( mix( dot( hash( i + vec2(0.0,0.0) ), f - vec2(0.0,0.0) ), 
                     dot( hash( i + vec2(1.0,0.0) ), f - vec2(1.0,0.0) ), u.x),
                mix( dot( hash( i + vec2(0.0,1.0) ), f - vec2(0.0,1.0) ), 
                     dot( hash( i + vec2(1.0,1.0) ), f - vec2(1.0,1.0) ), u.x), u.y);
}


void main(){

	
	vec4 basePx = texture2D(sampler, v_texcoord);
	vec2 p = v_texcoord.xy / (resolution.xy);
	
	vec2 uv = v_texcoord.xy;
		
	float f = 0.0;
	
	uv *= 8.0;
    mat2 m = mat2( 1.6,  1.2, -1.2,  1.6 );
	f  = 0.5000*noise( uv ); uv = m*uv;
	f += 0.2500*noise( uv ); uv = m*uv;
	f += 0.1250*noise( uv ); uv = m*uv;
	f += 0.0625*noise( uv ); uv = m*uv;
	
	vec2 uv2;
	
	uv2.x = v_texcoord.x ;
	uv2.y = v_texcoord.y ;
	uv2 *= 10.0;
    float f2 = 0.0;
	f2  = 0.5000*noise( uv2 ); uv2 = m*uv2;
	f2 += 0.2500*noise( uv2 ); uv2 = m*uv2;
	f2 += 0.1250*noise( uv2 ); uv2 = m*uv2;
	f2 += 0.0625*noise( uv2 ); uv2 = m*uv2;
	
	f= f*0.5 + f2*0.5;
	
	float alpha = step(0.1,(basePx.r + basePx.g + basePx.b) / 3.0 );
	
	gl_FragColor.rgb = COLOR;
	gl_FragColor.a = f*5.0 * alpha;
	
}*/


/*precision highp float;


uniform LOWP sampler2D sampler;
uniform LOWP sampler2D sampler1;

varying vec2 v_texcoord;

void main(){

	
	vec4 basePx = texture2D(sampler, v_texcoord);
	vec4 maskPx = texture2D(sampler1, v_texcoord);
		
	gl_FragColor.rgb = basePx.rgb;
	gl_FragColor.a = maskPx.a*basePx.a*.5;
	
}*/
