#ifdef GL_ES
precision highp float;
#endif

uniform LOWP sampler2D sampler;
#if defined(ENGINE_OS_ANDROID)
	uniform LOWP sampler2D sampler1;
	uniform int CombinedTexture;
#endif

varying MEDIUMP vec2 v_texcoord;
varying LOWP vec4 v_color;

void main()
{
	LOWP vec4 color = texture2D(sampler, v_texcoord) * v_color;
#if defined(ENGINE_OS_ANDROID)
	if (CombinedTexture == 1){
		color.a = texture2D(sampler1, v_texcoord).r * v_color.a;
	}
#endif

	float c = dot(color.rgb, vec3(0.3, 0.59, 0.21));
	color.r = 0.0;
	color.g = c * 0.6;
	color.b = c * 0.91;

	gl_FragColor = color.rgba;
}
