#ifdef GL_ES
precision highp float;
#endif

uniform LOWP sampler2D sampler;
uniform LOWP sampler2D sampler2;
uniform LOWP vec3 u_fogColor;
uniform float u_alpha;

varying MEDIUMP vec2 v_texcoord;
varying float v_density;
varying float v_light;
varying LOWP vec4 v_color;

void main()
{
	LOWP vec4 tex = v_color * texture2D(sampler, v_texcoord);
	LOWP vec4 mask = texture2D(sampler2, v_texcoord);
	
	LOWP vec3 color = tex.rgb;
	float emissive = max(0.0, 0.035 * (20.0 - v_light)) * mask.r;
	
	color -= (color - u_fogColor) * v_density * (1.0 - emissive * mask.r);
	color += emissive*emissive*1.5;

	gl_FragColor = vec4(color, tex.a);
	gl_FragColor.a *= u_alpha;
}
