#ifdef GL_ES
precision highp float;
#endif

varying vec2 v_texcoord;

uniform float color_mix;
uniform float global_a;

vec3 COLOR_DEFAULT = vec3(0.254, 0.439, 0.596);
vec3 COLOR_ACTIVE = vec3(0.878, 0.047, 0.231);

const float BLUR = 0.9;

void main()
{
	vec2 v = v_texcoord - vec2(0.5);
	float len = length(v);
	float p = len / 0.5;

	gl_FragColor.rgb = mix(COLOR_DEFAULT, COLOR_ACTIVE, color_mix);
	gl_FragColor.a = 1.0 - max(0.0, (p - BLUR) / (1.0 - BLUR));
	gl_FragColor.a *= global_a;
}