#ifdef GL_ES
precision highp float;
#endif

/*
//вариант с картой углов поворота в текстуре не удался, т.к. при маленьком разрешении текстуры появляются артефакты


uniform LOWP sampler2D sampler;
#if defined(ENGINE_OS_ANDROID)
	uniform LOWP sampler2D sampler1;
	uniform int CombinedTexture;
#endif

#define COLOR vec3(1.0, 0.564, 0.0)


uniform float angle;
uniform float global_a;

varying vec2 v_texcoord;



void main()
{
	vec4 basePx = texture2D(sampler, v_texcoord);
#if defined(ENGINE_OS_ANDROID)
	if (CombinedTexture == 1){
		basePx.a = texture2D(sampler1, v_texcoord).r ;
	}
#endif
	
	gl_FragColor.rgb = COLOR;
	gl_FragColor.a = (1.0 - step(angle, basePx.b)) * basePx.a;
	gl_FragColor.a *= global_a;	
}
*/

#define PI 3.14159265359
#define PI05 1.57079632679

#define COLOR vec3(1.0, 0.564, 0.0)

uniform float angle;
uniform float global_a;

varying vec2 v_texcoord;


void main()
{
	gl_FragColor.rgb = COLOR;
		
	vec2 coords = v_texcoord - vec2(0.5);
	float deg = atan(coords.y, coords.x);
	deg -= step(PI05,deg) * 2.0 * PI;

	float a = step(deg, PI05) * step(PI05 - angle, deg);
	
	gl_FragColor.a =  a * step(length(coords),0.5) * global_a;
}