#ifdef GL_ES
precision highp float;
#endif

uniform LOWP sampler2D sampler;
uniform LOWP sampler2D sampler1;
uniform LOWP float alpha;
varying vec2 v_texcoord;

const float ABS_OFFSET = 0.02;

void main(void)
{
	LOWP vec4 distortPx = texture2D(sampler1, v_texcoord);
	LOWP vec4 offsetColor;
	vec2 offsetPos = v_texcoord;
	
	vec3 normal;
	normal = 2.0*distortPx.rgb - 1.0;
	normal = normalize(normal);
	normal *= ABS_OFFSET * distortPx.a;
	
	offsetPos = v_texcoord + normal.xy;
	offsetColor = texture2D(sampler, offsetPos);
	//offsetColor.a*= distortPx.a;
	offsetColor.a*= alpha;
	offsetColor.rgb*= 1.0+offsetColor.a;
	
	gl_FragColor = offsetColor;
}