#ifdef GL_ES
precision highp float;
#endif

varying vec2 v_texcoord;

uniform float p;
uniform float bs;
uniform float be;
uniform float h1;
uniform float h2;

uniform LOWP sampler2D sampler;

const float K = -2.31;
const float B = 3.31;

void main(void)
{
	float y = K * v_texcoord.x + mix(bs, be, p) + mix(-h2, h2, p);
	float intensity1 = 1.0 + step(y - h1, v_texcoord.y) * step(v_texcoord.y, y + h1);
	float intensity2 = 1.0 + step(y - h2, v_texcoord.y) * step(v_texcoord.y, y + h2);
	gl_FragColor = texture2D(sampler, v_texcoord);
	gl_FragColor.rgb *= intensity1 * intensity2;
}