attribute vec4 a_vertex;
attribute vec2 a_texcoord;
attribute LOWP vec4 a_color;

uniform mat4 u_modelview;
uniform LOWP float u_fade;

varying vec2 v_texcoord;
varying LOWP vec4 v_color;
varying vec4 screenCoord;
varying vec4 v_causticsCoord;

void main()
{
	v_color = a_color;
	v_texcoord = a_texcoord;

	vec4 screenPos = u_modelview * a_vertex;
	gl_Position = screenPos;
	
	screenPos.xy = screenPos.xy / screenPos.w;
	// коэффициенты координат подобраны для синусоидальных волн
	// в zw передается реальная screenPos.x а также точка в диапазоне [0;1], с которой начинать укасание каустики; 0 - низ
	screenCoord = vec4(screenPos.x * 512.0, 0.05 * (-screenPos.y - 1.0), (screenPos.y * .5 + .5), u_fade);
	
	//float projX = 0.5 + 0.5 * screenPos.x * (1.5 + 0.5 * screenPos.y);
	//v_causticsCoord = vec4(projX, screenPos.y, 1.0, 1.0);

	vec2 normCoord = screenPos.xy * 0.5 + vec2(0.5, 0.5);
	v_causticsCoord = vec4(normCoord.x - 0.5, 5.0 * normCoord.y + 1.0, normCoord.y, 1.0);
}
