attribute vec4 a_vertex;
attribute vec4 a_color;
attribute vec2 a_texcoord;
attribute vec2 a_texcoord1; // a_expand;
attribute vec2 a_texcoord2; // a_move;

uniform mat4 u_modelview;
uniform float u_time;

varying vec2 v_texcoord;
varying MEDIUMP float v_alpha;

void main()
{
	float lt = max(u_time - 1.1 * (a_vertex.z - 0.05), 0.0);
	float decrease = clamp(1.0 - 0.95 * lt, 0.0, 1.0);
	float phase = 1.4 * a_color.r * min(5.0 * lt, decrease * decrease);
	v_alpha = phase * a_color.a;
	
	float dist = lt;

	vec4 pos = vec4(a_vertex.xy + a_texcoord1.xy * 30.0 * phase + vec2(0.0, 1.0) * dist * 100.0 + a_texcoord2.xy * phase * 500.0, 0.0, 1.0);
	
	v_texcoord = a_texcoord;
	gl_Position = u_modelview * pos;
}
