#ifdef GL_ES
precision highp float;
#endif

uniform LOWP sampler2D sampler;
uniform LOWP sampler2D sampler2;
uniform LOWP sampler2D sampler3;
uniform LOWP float u_alpha;

varying vec2 v_texcoord;
varying vec2 v_maskTexcoord;
varying vec2 v_bubbleTexcoord;

void main()
{
	LOWP vec4 dynScreen = texture2D(sampler, v_texcoord);
	LOWP vec4 mask = texture2D(sampler2, v_maskTexcoord);
	LOWP vec4 bubble = texture2D(sampler3, v_bubbleTexcoord);

	LOWP vec4 color = dynScreen - (dynScreen - bubble) * bubble.a * (1.0 - u_alpha);
	gl_FragColor = vec4(color.rgb, max(u_alpha, 1.0 - mask.a));
}
