#ifdef GL_ES
precision highp float;
#endif

uniform LOWP sampler2D   sampler;
#if defined(ENGINE_OS_ANDROID)
	uniform LOWP sampler2D sampler1;
	uniform int CombinedTexture;
#endif

uniform LOWP sampler2D sampler2;
#if defined(ENGINE_OS_ANDROID)
	uniform LOWP sampler2D sampler3;
#endif

uniform float u_time;         // u_time умножено в коде на 3.0
uniform LOWP  float u_intensity;
uniform LOWP float u_fade;			// затухание каустики, 0 - линейное угасание по вертикали, 0.5 - угасание за половину экрана, затухание снизу вверх

varying vec2        v_texcoord;
varying LOWP vec4   v_color;
varying vec3  screenCoord;

void main()
{
	LOWP vec4 tex = texture2D(sampler, v_texcoord);
#if defined(ENGINE_OS_ANDROID)
	if (CombinedTexture == 1){
		tex.a = texture2D(sampler1, v_texcoord).r;
	}
#endif

	float causticSim = sin(tex.g * screenCoord.x * screenCoord.y + u_time) * u_intensity;

	// освещенность
	float lightness = min(1.0, (tex.r + tex.g + tex.b) * 0.5);

	// выделяем некий средний "слой"
	// в этот слой не попадают темные и самые яркие фрагменты
	lightness = lightness * lightness * (1.0 - lightness);
	
	float vertSkip = 1.0 - clamp((screenCoord.z - u_fade) / (1.0 - u_fade), 0.0, 1.0);

	gl_FragColor = v_color * tex + causticSim * tex.a * lightness * vertSkip;
	
	// просмотр маски lightness
	// gl_FragColor.rgb = vec3(lightness, lightness, lightness);
}
