attribute vec4 a_vertex;
attribute vec2 a_texcoord;
attribute LOWP vec4 a_color;

uniform mat4 u_modelview;

varying vec2 v_texcoord;
varying LOWP vec4 v_color;
varying vec3 screenCoord;

void main()
{
	v_color = a_color;
	v_texcoord = a_texcoord;

	vec4 screenPos = u_modelview * a_vertex;
	gl_Position = screenPos;
	
	screenPos.xy = screenPos.xy / screenPos.w;
	// коэффициенты координат подобраны для синусоидальных волн
	// в z передается реальная screenPos.y
	screenCoord = vec3(screenPos.x * 512.0, 0.05 * (-screenPos.y - 1.0), (screenPos.y * .5 + .5));
}
