#ifdef GL_ES
precision highp float;
#endif

uniform sampler2D   sampler;
#if defined(ENGINE_OS_ANDROID)
	uniform LOWP sampler2D sampler1;
	uniform int CombinedTexture;
#endif

uniform sampler2D sampler2;
#if defined(ENGINE_OS_ANDROID)
	uniform LOWP sampler2D sampler3;
#endif

uniform float u_time;         // u_time умножено в коде на 3.0
uniform LOWP  float u_intensity;
uniform LOWP float u_fade;			// затухание каустики, 0 - линейное угасание по вертикали, 0.5 - угасание за половину экрана, затухание снизу вверх

varying vec2        v_texcoord;
varying LOWP vec4   v_color;
varying vec3  screenCoord;

void main()
{
	LOWP vec4 tex = texture2D(sampler, v_texcoord);
#if defined(ENGINE_OS_ANDROID)
	if (CombinedTexture == 1){
		tex.a = texture2D(sampler1, v_texcoord).r;
	}
#endif

	gl_FragColor = v_color * tex;
}
