#ifdef GL_ES
precision highp float;
#endif

#define PI 3.14159265359

varying vec2 v_texcoord;

uniform float p;
uniform float bs;
uniform float be;
uniform float h;
uniform float k;


uniform LOWP sampler2D sampler;

#if defined(ENGINE_OS_ANDROID)
	uniform LOWP sampler2D sampler1;
	uniform int CombinedTexture;
#endif


//Calculate Intensity
float ci(float y, float h)
{
	float i = clamp((v_texcoord.y - y + h)/(h*2.0),0.0,1.0);
	return 0.5 - 0.5 * cos(PI* 2.0 * i);
}

void main(void)
{
	float y = k * v_texcoord.x + mix(bs + h , be - h, p);
	gl_FragColor = texture2D(sampler, v_texcoord);
	float i = ci(y, h);
	 vec3 add = mix(gl_FragColor.rgb, vec3(1.0,1.0,1.0), 0.7* i);
	 gl_FragColor.rgb += add*i;
	
#if defined(ENGINE_OS_ANDROID)
	if (CombinedTexture == 1){
		gl_FragColor.a = texture2D(sampler1, v_texcoord).r;
	}
#endif
}