#ifdef GL_ES
precision highp float;
#endif

#define PI 3.14159265359

varying vec2 v_texcoord;

uniform LOWP sampler2D sampler;
uniform float p;

#if defined(ENGINE_OS_ANDROID)
	uniform LOWP sampler2D sampler1;
	uniform int CombinedTexture;
#endif

const float BLUE_TRESHOLD = 0.5;


void main(void)
{
	gl_FragColor = texture2D(sampler, v_texcoord);
	float bluestep = step(BLUE_TRESHOLD, gl_FragColor.b);
	 vec3 add = bluestep * mix(gl_FragColor.rgb, vec3(1.0,1.0,1.0), 0.5) * (0.5 - 0.5 * cos(2.0 * PI * p));
	 gl_FragColor.rgb += add;
	
#if defined(ENGINE_OS_ANDROID)
	if (CombinedTexture == 1){
		gl_FragColor.a = texture2D(sampler1, v_texcoord).r;
	}
#endif
}