#if defined(GL_ES) && !defined(LOWP)
#define LOWP lowp
#define MEDIUMP mediump
#define HIGHP highp
#endif

attribute vec3 a_vertex;

uniform mat4 u_modelview;
uniform MEDIUMP vec3 u_time_distPower;
uniform vec4 u_TexcoordXfm;

varying vec2 v_texcoord;

void main()
{
	vec4 pos = u_modelview[0] * a_vertex.x + u_modelview[1] * a_vertex.y + u_modelview[3];

	v_texcoord = a_vertex.xy * u_TexcoordXfm.xy + u_TexcoordXfm.zw;

	MEDIUMP vec2 distPower = u_time_distPower.yz;
	MEDIUMP float vertDistK = a_vertex.z;
	MEDIUMP float time = u_time_distPower.x;
	MEDIUMP float phase = pos.x;

	v_texcoord += distPower.xy * sin(phase * 9.0 + time) * vertDistK;

	gl_Position = pos;
}
