#if defined(GL_ES) && !defined(LOWP)
#define LOWP lowp
#define MEDIUMP mediump
#define HIGHP highp
#endif

#ifdef GL_ES
precision highp float;
#endif

uniform sampler2D   sampler;
#if defined(ENGINE_OS_ANDROID)
	uniform LOWP sampler2D sampler1;
	uniform int CombinedTexture;
#endif

uniform sampler2D sampler2;
#if defined(ENGINE_OS_ANDROID)
	uniform LOWP sampler2D sampler3;
#endif

uniform LOWP  float u_animIntensity;

varying vec2      v_texcoord;
varying vec2      v_animCoord;
varying float     v_falloff;
varying float     v_w;

void main()
{
	LOWP vec4 tex = texture2D(sampler, v_texcoord);
#if defined(ENGINE_OS_ANDROID)
	if (CombinedTexture == 1){
		tex.a = texture2D(sampler1, v_texcoord).r;
	}
#endif

	vec2 animUV = v_animCoord.xy / max(v_w, 0.01);
	
	float animFalloff = clamp(v_falloff, 0.0, 1.0);
	vec4 animColor = texture2D(sampler2, animUV);
#if defined(ENGINE_OS_ANDROID)
	if (CombinedTexture == 1){
		animColor.a = texture2D(sampler3, animUV).r;
	}
#endif

	gl_FragColor = tex + animColor * animFalloff * u_animIntensity * tex.a;
}
