#if defined(GL_ES) && !defined(LOWP)
#define LOWP lowp
#define MEDIUMP mediump
#define HIGHP highp
#endif

attribute vec3 a_vertex;

uniform mat4 u_modelview;
uniform vec4 u_TexcoordXfm[3];

uniform MEDIUMP vec3 u_time_distPower;

varying vec2 v_texcoord;
varying vec2 v_animCoord;
varying float v_falloff;
varying float v_w;


void main()
{
	vec4 screenPos = u_modelview[0] * a_vertex.x + u_modelview[1] * a_vertex.y + u_modelview[3];
	v_texcoord = a_vertex.xy * u_TexcoordXfm[0].xy + u_TexcoordXfm[0].zw;

	MEDIUMP vec2 distPower = u_time_distPower.yz;
	MEDIUMP float vertDistK = a_vertex.z;
	MEDIUMP float time = u_time_distPower.x;
	MEDIUMP float phase = screenPos.x;

	v_texcoord += distPower.xy * sin(phase * 9.0 + time) * vertDistK;

	gl_Position = screenPos;
	
	// Engine uses ortho projection for 2D drawing, no need to do perspective division
	v_animCoord.x = screenPos.x;
	v_animCoord.y = screenPos.y * u_TexcoordXfm[1].x + u_TexcoordXfm[2].x;
	v_falloff = screenPos.y * u_TexcoordXfm[1].y + u_TexcoordXfm[2].y;
	v_w = screenPos.y * u_TexcoordXfm[1].z + u_TexcoordXfm[2].z;
}
