#if defined(GL_ES) && !defined(LOWP)
#define LOWP lowp
#define MEDIUMP mediump
#define HIGHP highp
#endif

attribute vec3 a_vertex;

uniform mat4 u_modelview;
uniform MEDIUMP vec2 u_distPower_Time;
uniform vec4 u_TexcXforms[2];

varying vec2 v_texcoord;
varying MEDIUMP vec2 v_causticsCoord;

void main()
{
	vec4 pos = u_modelview[0] * a_vertex.x + u_modelview[1] * a_vertex.y + u_modelview[3];

	MEDIUMP float distortK = u_distPower_Time.x * a_vertex.z;
	MEDIUMP float sinPhase = pos.x * 9.0 + u_distPower_Time.y;
	
	v_texcoord = a_vertex.xy * u_TexcXforms[0].xy + u_TexcXforms[0].zw + sin(sinPhase) * distortK;

	gl_Position = pos;
	
	// a_vertex is in screen coordinates normalized to [0,1] 
	v_causticsCoord = a_vertex.xy;
	
	MEDIUMP vec2 causticScale = u_TexcXforms[1].xy;
	v_causticsCoord = v_causticsCoord * causticScale;
		
	MEDIUMP vec2 xyFactor = u_TexcXforms[1].zw;
	v_causticsCoord = mix(vec2(1.0, 1.0), v_causticsCoord.xy, xyFactor.xy);

}
