#ifdef GL_ES
precision highp float;
#if !defined(LOWP)
#define LOWP lowp
#define MEDIUMP mediump
#define HIGHP highp
#endif
#endif

uniform LOWP sampler2D   sampler;
#if defined(ENGINE_OS_ANDROID)
	uniform LOWP sampler2D sampler1;
	uniform int CombinedTexture;
#endif

varying vec2 v_texcoord;
varying MEDIUMP vec4 v_color;

void main()
{
	MEDIUMP vec4 color = texture2D(sampler, v_texcoord);
#if defined(ENGINE_OS_ANDROID)
	if (CombinedTexture == 1){
		color.a = texture2D(sampler1, v_texcoord).r;
	}
#endif

	gl_FragColor = color * v_color;
}
