#ifdef GL_ES
precision highp float;
#if !defined(LOWP)
#define LOWP lowp
#define MEDIUMP mediump
#define HIGHP highp
#endif
#endif

uniform LOWP sampler2D sampler;
uniform LOWP sampler2D sampler1;
uniform LOWP sampler2D sampler2;
uniform LOWP vec4 u_waterColor;
uniform MEDIUMP vec2 u_intensity;

varying vec4 v_waterCoords;
varying vec2 v_backCoords;
varying vec2 v_texcoord;

void main()
{
	// Black & White surface mask
	MEDIUMP float mask = texture2D(sampler1, v_texcoord.xy).r * 2.0;
	
	LOWP vec4 backgroundMask = texture2D(sampler2, v_backCoords);
	mask *= 1.0 - backgroundMask.a;	

	LOWP vec2 col0 = texture2D(sampler, v_waterCoords.xy).rg;
	LOWP vec2 col1 = texture2D(sampler, v_waterCoords.zw).rg;

	MEDIUMP float wave = (col0.r + col1.r) * u_intensity.y;
	MEDIUMP vec4 col = vec4(wave, wave, wave, mask);
	
	//overbrights
	MEDIUMP float light = min(0.02, pow(col0.g * col1.g, 5.0) * 25.0);
	col.rgb += light * u_intensity.x;
	
	// fish tank color
	col *= u_waterColor;

	// BlendMode Add is used in code, pre-multiply by alpha
	col *= col.a;
	
	gl_FragColor = col;//vec4(backgroundMask.a, backgroundMask.a, backgroundMask.a, 1.0);
}
