#if defined(GL_ES) && !defined(LOWP)
#define LOWP lowp
#define MEDIUMP mediump
#define HIGHP highp
#endif

attribute vec2 a_vertex;

uniform mat4 u_modelview;
uniform vec3 u_time;
uniform float u_verticalScale;
uniform vec2 u_scale;

uniform vec4 u_TexcoordXfm[2];

varying vec4 v_waterCoords;
varying vec2 v_backCoords;
varying vec2 v_texcoord;

void main()
{
	vec2 texc = a_vertex.xy * u_TexcoordXfm[0].xy + u_TexcoordXfm[0].zw;
	
	// water mask texcoords
	v_texcoord.xy = texc;
	
	v_backCoords = a_vertex.xy * u_TexcoordXfm[1].xy + u_TexcoordXfm[1].zw;
	
	// stretch water coord horizontaly
	MEDIUMP float waterXCoord = texc.x * u_scale.x;
	
	// vertical waves
	float vertShift = sin(texc.x * 10.0 + u_time.z) * 0.017;
		
	v_waterCoords.xyzw = vec2(waterXCoord, texc.y * u_scale.y + vertShift ).xyxy;

	// smaller waves
	v_waterCoords.xy += u_time.xx;	
	v_waterCoords.zw += -u_time.xy;
	
	gl_Position = u_modelview[0] * a_vertex.x + u_modelview[1] * a_vertex.y + u_modelview[3];
}
