#ifdef GL_ES
precision highp float;
#endif

varying LOWP vec4 v_color;
varying vec2 v_texcoord;

uniform LOWP sampler2D sampler;
uniform vec2 blurSize;

uniform int enableBlur;

void main()
{
	if (enableBlur == 1) {
		vec2 v_tc = v_texcoord;
		float sum = 0.0;

		// http://dev.theomader.com/gaussian-kernel-calculator/
		// sigma = 2
		sum += texture2D(sampler, vec2(v_tc.x - 2.0*blurSize.x, v_tc.y - 2.0*blurSize.y)).r * 0.023528;
		sum += texture2D(sampler, vec2(v_tc.x + 2.0*blurSize.x, v_tc.y - 2.0*blurSize.y)).r * 0.023528;
		sum += texture2D(sampler, vec2(v_tc.x + 2.0*blurSize.x, v_tc.y + 2.0*blurSize.y)).r * 0.023528;
		sum += texture2D(sampler, vec2(v_tc.x - 2.0*blurSize.x, v_tc.y + 2.0*blurSize.y)).r * 0.023528;
		
		sum += texture2D(sampler, vec2(v_tc.x - 2.0*blurSize.x, v_tc.y - 1.0*blurSize.y)).r * 0.033969;
		sum += texture2D(sampler, vec2(v_tc.x - 2.0*blurSize.x, v_tc.y + 1.0*blurSize.y)).r * 0.033969;
		sum += texture2D(sampler, vec2(v_tc.x + 2.0*blurSize.x, v_tc.y - 1.0*blurSize.y)).r * 0.033969;
		sum += texture2D(sampler, vec2(v_tc.x + 2.0*blurSize.x, v_tc.y + 1.0*blurSize.y)).r * 0.033969;
		sum += texture2D(sampler, vec2(v_tc.x - 1.0*blurSize.x, v_tc.y - 2.0*blurSize.y)).r * 0.033969;
		sum += texture2D(sampler, vec2(v_tc.x + 1.0*blurSize.x, v_tc.y - 2.0*blurSize.y)).r * 0.033969;
		sum += texture2D(sampler, vec2(v_tc.x - 1.0*blurSize.x, v_tc.y + 2.0*blurSize.y)).r * 0.033969;
		sum += texture2D(sampler, vec2(v_tc.x + 1.0*blurSize.x, v_tc.y + 2.0*blurSize.y)).r * 0.033969;
		
		sum += texture2D(sampler, vec2(v_tc.x, v_tc.y - 2.0*blurSize.x)).r * 0.038393;
		sum += texture2D(sampler, vec2(v_tc.x + 2.0*blurSize.x, v_tc.y)).r * 0.038393;
		sum += texture2D(sampler, vec2(v_tc.x, v_tc.y + 2.0*blurSize.y)).r * 0.038393;
		sum += texture2D(sampler, vec2(v_tc.x - 2.0*blurSize.x, v_tc.y)).r * 0.038393;
	
		sum += texture2D(sampler, vec2(v_tc.x - 1.0*blurSize.x, v_tc.y - 1.0*blurSize.y)).r * 0.049045;
		sum += texture2D(sampler, vec2(v_tc.x + 1.0*blurSize.x, v_tc.y - 1.0*blurSize.y)).r * 0.049045;
		sum += texture2D(sampler, vec2(v_tc.x + 1.0*blurSize.x, v_tc.y + 1.0*blurSize.y)).r * 0.049045;
		sum += texture2D(sampler, vec2(v_tc.x - 1.0*blurSize.x, v_tc.y + 1.0*blurSize.y)).r * 0.049045;
		
		sum += texture2D(sampler, vec2(v_tc.x, v_tc.y - 1.0*blurSize.y)).r * 0.055432;
		sum += texture2D(sampler, vec2(v_tc.x + 1.0*blurSize.x, v_tc.y)).r * 0.055432;
		sum += texture2D(sampler, vec2(v_tc.x, v_tc.y + 1.0*blurSize.y)).r * 0.055432;
		sum += texture2D(sampler, vec2(v_tc.x - 1.0*blurSize.x, v_tc.y)).r * 0.055432;
	
		sum += texture2D(sampler, vec2(v_tc.x, v_tc.y)).r * 0.062651;
		
		gl_FragColor = vec4(0.0, 0.0, 0.0, 1.0 - sum);
	}
	else {
		vec4 color = texture2D(sampler, v_texcoord);

		color.a = 1.0 - color.r;
		gl_FragColor = color;
	}
}
