#ifdef GL_ES
precision highp float;
#ifndef LOWP
#define LOWP lowp
#define MEDIUMP mediump
#define HIGHP highp
#endif
#endif

uniform LOWP sampler2D   sampler;
#if defined(ENGINE_OS_ANDROID)
	uniform LOWP sampler2D sampler1;
	uniform int CombinedTexture;
#endif

uniform LOWP sampler2D sampler2;
#if defined(ENGINE_OS_ANDROID)
	uniform LOWP sampler2D sampler3;
#endif

varying vec2        v_texcoord;
varying LOWP vec4   v_color;
varying MEDIUMP vec3 v_params;
varying vec2  screenCoord;

void main()
{
	LOWP vec4 bubble = texture2D(sampler, v_texcoord);
#if defined(ENGINE_OS_ANDROID)
	if (CombinedTexture == 1){
		bubble.a = texture2D(sampler1, v_texcoord).r;
	}
#endif

	LOWP vec4 back = texture2D(sampler2, screenCoord);
#if defined(ENGINE_OS_ANDROID)
	if (CombinedTexture == 1){
		back.a = texture2D(sampler3, screenCoord).r;
	}
#endif

	MEDIUMP float mainPart = v_params.x;
	MEDIUMP float selfPart = v_params.y;
	MEDIUMP float backContrast = v_params.z;

	back = vec4(0.5, 0.5, 0.5, 0.5) - backContrast * (vec4(0.5, 0.5, 0.5, 0.5) - back);

	LOWP vec4 col;
	col.rgb = back.rgb * mainPart + bubble.rgb * selfPart;
	
	col.a = bubble.a * v_color.a;
	
	gl_FragColor = col;
}
