#if defined(GL_ES) && !defined(LOWP)
#define LOWP lowp
#define MEDIUMP mediump
#define HIGHP highp
#endif

attribute vec4 a_vertex;
attribute vec2 a_texcoord;
attribute LOWP vec4 a_color;
attribute MEDIUMP vec4 a_texcoord1;
attribute MEDIUMP vec4 a_texcoord2;

uniform mat4 u_modelview;
uniform vec2 u_offset;

varying vec2 v_texcoord;
varying MEDIUMP vec3 v_params;
varying LOWP vec4 v_color;
varying vec2 screenCoord;

void main()
{
	v_color = a_color;
	v_texcoord = a_texcoord;
	
	v_params = a_texcoord1.xyz * vec3(3.0, 3.0, 3.0);

	vec4 screenPos = u_modelview * a_vertex;
	gl_Position = screenPos;
	
	screenCoord += screenPos.xy * 0.5 + a_texcoord2.xy * 0.25 - vec2(0.125, 0.125) + vec2(0.5, 0.5);
}
