#ifdef GL_ES
precision highp float;
#endif

// Основной шейдер первого слоя нефти и янтаря

varying MEDIUMP vec2 v_normal;
varying MEDIUMP vec2 v_texcoord;
varying LOWP vec4 v_color;

uniform LOWP sampler2D sampler;
uniform LOWP vec3 frontColor;

/*
	v_normal - направление края нефти, 2д-вектор
	v_texcoord - глубина нефти, используется только x-координата (которая на самом деле y в OptTex) масштабирована в 4 раза (т.е. [0.f;4.f])
	v_color.r - альфа всей клетки, для эффекта появления поля
	v_color.a - альфа узла, для растекания нефти
*/
void main()
{
	float p = dot(vec2(0.707107,-0.707107), normalize(v_normal));

	LOWP vec4 color = texture2D(sampler, vec2(p*0.5+0.5, v_texcoord.x * 0.25));

	float a=v_color.a*(1.0/0.2) * color.a;
	float t=(v_color.a-0.5)*(1.0/0.5);
	color=mix(vec4(frontColor, min(1.0,a)), color, max(0.0,t));

	color.a*=v_color.x;

	gl_FragColor = color;
}
