#ifdef GL_ES
precision highp float;
#endif

// Отрисовка в таргет внутренней части янтаря.
// В дальнейшем размывается и используется для
// - плавного градиента внутри первого слоя янтаря
// - корректного обрезания светящейся границы между первым и вторым слоями янтаря 

varying MEDIUMP vec2 v_normal;
varying MEDIUMP vec2 v_texcoord;
varying LOWP vec4 v_color;

/*
	v_normal - направление края нефти, 2д-вектор
	v_texcoord - глубина нефти, используется только x-координата (которая на самом деле y в OptTex) масштабирована в 4 раза (т.е. [0.f;4.f])
	v_color.r - альфа всей клетки, для эффекта появления поля
	v_color.a - альфа узла, для растекания нефти
*/
void main()
{
	// r-канал - видимая внутренность янтаря темно-оранжевого цвета
	// g-канал - используется как маска для обрезания светящейся границы между первым и вторым слоями янтаря
	gl_FragColor.r = step(3.0, v_texcoord.x);
	gl_FragColor.g = step(0.5, v_texcoord.x);
	gl_FragColor.b = 0.0;
	gl_FragColor.a = 1.0;
}
