#ifdef GL_ES
precision highp float;
#endif

// Размытие таргета с внутренней частью нефти. Используется в два прохода.
varying MEDIUMP vec2 v_normal;
varying MEDIUMP vec2 v_texcoord;
varying LOWP vec4 v_color;

uniform LOWP sampler2D sampler;
uniform vec2 blurDir;

void main()
{
	// константы сгенерированы генератором http://dev.theomader.com/gaussian-kernel-calculator/
	// параметры: sigma 3 kernel 11
	float kernel1 = 0.141836;
	float kernel2 = 0.13424;
	float kernel3 = 0.113806;
	float kernel4 = 0.086425;
	float kernel5 = 0.05879;
	float kernel6 = 0.035822;
	
	MEDIUMP vec2 t = v_texcoord;
	LOWP vec2 sum = vec2(0.0);
	
	LOWP vec4 centerColor = texture2D(sampler, t);
	
	sum += texture2D(sampler, t - 5.0 * blurDir).rg * kernel6;
	sum += texture2D(sampler, t - 4.0 * blurDir).rg * kernel5;
	sum += texture2D(sampler, t - 3.0 * blurDir).rg * kernel4;
	sum += texture2D(sampler, t - 2.0 * blurDir).rg * kernel3;
	sum += texture2D(sampler, t - 1.0 * blurDir).rg * kernel2;
	sum += centerColor.rg * kernel1;
	sum += texture2D(sampler, t + 1.0 * blurDir).rg * kernel2;
	sum += texture2D(sampler, t + 2.0 * blurDir).rg * kernel3;
	sum += texture2D(sampler, t + 3.0 * blurDir).rg * kernel4;
	sum += texture2D(sampler, t + 4.0 * blurDir).rg * kernel5;
	sum += texture2D(sampler, t + 5.0 * blurDir).rg * kernel6;

	// Имитация CLAMP_TO_BORDER
	// Принудительно присваиваем 0 цвет точкам на границе (blueDir соответсвует размеру 1 пиксела)
	sum.rg *= step(blurDir.x, t.x) * step(blurDir.y, t.y) * step(blurDir.x, 1.0 - t.x) * step(blurDir.y, 1.0 - t.y);

	gl_FragColor = vec4(sum, 0.0, 1.0);
}
