#ifdef GL_ES
precision highp float;
#endif

uniform LOWP sampler2D sampler;
varying LOWP vec4 v_color;
varying vec2 v_texcoord;

uniform LOWP vec3 u_fogColor;
uniform MEDIUMP float u_density;

void main()
{
	LOWP vec4 texColor = v_color * texture2D(sampler, v_texcoord);
	LOWP vec3 color = texColor.rgb;
	
	color -= (color - u_fogColor) * u_density;
	gl_FragColor = vec4(color, texColor.a);
}
