#ifdef GL_ES
precision highp float;
#endif

#define PI 3.14159265359

varying vec2 v_texcoord;
uniform float p;

uniform LOWP sampler2D sampler;

#if defined(ENGINE_OS_ANDROID)
	uniform LOWP sampler2D sampler1;
	uniform int CombinedTexture;
#endif

const float K = 0.5;
const float H = 0.233;
const float BS = -H;
const float BE = 1.0 + H - K;
const float TRESHOLD = 0.65;
const vec3 COLOR = vec3(1.0,0.95,0.48);

void main(void)
{
	float y = K * v_texcoord.x + mix(BS, BE, p);
	gl_FragColor = texture2D(sampler, v_texcoord);
	float i = clamp((v_texcoord.y - y + H)/(H*2.0),0.0,1.0);
	float grayscale = 0.299 * gl_FragColor.r + 0.587 * gl_FragColor.g + 0.114 * gl_FragColor.b;
	float intensity = 0.5 * clamp(grayscale/TRESHOLD,0.0,1.0);
	gl_FragColor.rgb += COLOR* intensity * (0.5 - 0.5 * cos(i * PI * 2.0));
#if defined(ENGINE_OS_ANDROID)
	if (CombinedTexture == 1){
		gl_FragColor.a = texture2D(sampler1, v_texcoord).r;
	}
#endif
}