#ifdef GL_ES
precision highp float;
#endif

#if defined(ENGINE_OS_ANDROID)
	uniform LOWP sampler2D sampler1;
	uniform int CombinedTexture;
#endif

varying vec2 v_texcoord;

uniform float alpha;
uniform float overglow;
uniform float line_p;
uniform float line_bs;
uniform float line_be;
uniform float line_h;

uniform LOWP sampler2D sampler;

const float PI = 3.14159265359;
const float LINE_K = -1.0;

float ci(float y, float h)
{
	float i = clamp((v_texcoord.y - y + h)/(h*2.0), 0.0, 1.0);
	return (0.5 - 0.5 * cos(PI * 2.0 * i));
}

void main(void)
{
	gl_FragColor = texture2D(sampler, v_texcoord);

	float line_y = LINE_K * v_texcoord.x + mix(line_bs - line_h, line_be + line_h, line_p);

	float fastp = overglow * 1.7;
	
	gl_FragColor.rg += (1.0 - gl_FragColor.rg) * overglow;
	gl_FragColor.b += (1.0 - gl_FragColor.b) * fastp;
#if defined(ENGINE_OS_ANDROID)
	if (CombinedTexture == 1) {
		gl_FragColor.a = texture2D(sampler1, v_texcoord).r * alpha;
	}
	else
#endif
	{
		gl_FragColor.a *= alpha;
	}
	
	gl_FragColor.rgb += (1.0 - gl_FragColor.rgb)*ci(line_y, line_h);
}