attribute vec4 a_vertex;
attribute vec4 a_color;
attribute vec2 a_texcoord;
attribute vec2 a_texcoord1; // a_expand;
attribute vec2 a_texcoord2; // a_move;

uniform mat4 u_modelview;
uniform float u_time;
uniform LOWP float u_colorG;
uniform LOWP float u_colorB;
uniform float u_size; // particle size


varying vec2 v_texcoord;
varying MEDIUMP float v_alpha;
varying LOWP vec4 v_color;

void main()
{
	float lt = max(u_time - 1.1 * (a_vertex.z - 0.05), 0.0);
	float decrease = clamp(1.0 - 0.95 * lt, 0.0, 1.0);
	float phase = 1.4 * a_color.r * min(5.0 * lt, decrease * decrease);
	v_alpha = phase;
	
	float dist = lt;

	vec4 pos = vec4(a_vertex.xy + a_texcoord1.xy * u_size * phase + vec2(0.0, 1.0) * dist * 100.0 + a_texcoord2.xy * phase * 500.0, 0.0, 1.0);
	
	v_texcoord = a_texcoord;
	v_color = vec4(a_color.b, u_colorG, u_colorB, a_color.a);
	gl_Position = u_modelview * pos;
}
