#ifdef GL_ES
precision highp float;
#endif

uniform LOWP sampler2D sampler;
#if defined(ENGINE_OS_ANDROID)
	uniform LOWP sampler2D sampler1;
	uniform int CombinedTexture;
#endif

varying vec2 v_texcoord;

uniform LOWP float u_shadowAlpha;

void main()
{
	LOWP float alpha = texture2D(sampler, v_texcoord).a;
	
#if defined(ENGINE_OS_ANDROID)
	if (CombinedTexture == 1) {
		alpha = texture2D(sampler1, v_texcoord).r;
	}
#endif

	gl_FragColor = vec4(vec3(0.0), u_shadowAlpha * alpha);
}
