#ifdef GL_ES
precision highp float;
#endif

varying vec2 v_texcoord;
varying vec2 v_coord;

uniform LOWP sampler2D sampler;
#if defined(ENGINE_OS_ANDROID)
	uniform LOWP sampler2D sampler1;
	uniform int CombinedTexture;
#endif

uniform vec2 u_linePos;
uniform vec2 u_lineNormal;
uniform float u_lineWidth;
uniform float u_intencity;

void main()
{
	gl_FragColor = texture2D(sampler, v_texcoord);
	#if defined(ENGINE_OS_ANDROID)
		if (CombinedTexture == 1) {
			gl_FragColor.a = texture2D(sampler1, v_texcoord).r;
		}
	#endif

	float dist = abs(dot(v_coord - u_linePos, u_lineNormal));
	float intencity = 1.0 - smoothstep(0.0, u_lineWidth, dist);
	gl_FragColor.rgb += intencity * u_intencity;
}
