#ifdef GL_ES
precision highp float;
#ifndef LOWP
#define LOWP lowp
#define MEDIUMP mediump
#endif
#endif

uniform sampler2D sampler;
uniform sampler2D sampler1;

varying MEDIUMP vec3 v_data;
varying MEDIUMP vec2 v_uv0;
varying MEDIUMP vec2 v_uv1;

void main()
{
	vec2 atlas_uv_left_top = (v_uv1 * 0.5) + vec2(0, 0.5);
	vec2 atlas_uv_right_top = atlas_uv_left_top + vec2(0.5, 0);
	vec2 atlas_uv_left_bottom = (v_uv0 * 0.5);
	vec2 atlas_uv_right_bottom_green = atlas_uv_left_bottom + vec2(0.5, 0);
	vec2 atlas_uv_right_bottom_redblue = (v_uv1 * 0.5) + vec2(0.5, 0);

	vec4 col = texture2D(sampler, v_uv0);
	float ao = texture2D(sampler1, atlas_uv_right_bottom_green).g;

	vec2 atlas_right_bottom = texture2D(sampler1, atlas_uv_right_bottom_redblue).rb;
	float spec = atlas_right_bottom.x;
	float fresnel = atlas_right_bottom.y;

	vec4 mcap1 = texture2D(sampler1, atlas_uv_left_top);
	vec4 mcap2 = texture2D(sampler1, atlas_uv_right_top);
	vec3 mask = texture2D(sampler1, atlas_uv_left_bottom).rgb;

	float light_scattering = v_data.x*v_data.y;
	light_scattering = clamp(4.0*light_scattering, 0.0, 1.0);

	float light_add = mix(0.0, 1.0, light_scattering*(0.5+0.5*ao));
	light_add = light_add * light_add * light_add * 3.0;
	light_add = (1.0-clamp(light_add, 0.0, 1.0))*fresnel;

	vec3 clr1 = vec3(0.7529, 0.7450, 1.0000);
	vec3 clr2 = vec3(1.0000, 0.9294, 0.6784);
	vec3 clr3 = vec3(0.6352, 0.7450, 1.0000);

	vec4 result;

	result.rgb = mix(col.rgb, mcap1.rgb*col.rgb.r, clamp(light_add+(1.0-light_scattering)*(1.0-ao), 0.0, 1.0)*(mcap1.a)*0.75 - 0.5*(1.0-v_data.y));
	result.rgb = mix(result.rgb, result.rgb*mcap2.rgb*1.5, light_scattering*fresnel * mcap2.a*0.5);
	float invDataY = 1.0-v_data.y;
	result.rgb = mix(result.rgb, clr1, 0.5*invDataY*invDataY);

	result.rgb += clamp(clr2*spec*0.25*(1.0-light_add*(1.0-v_data.y)), 0.0, 1.0);
	result.rgb = mix(result.rgb, min(result.rgb,clr3), mask.b*fresnel*fresnel*fresnel);
	result.rgb = mix(result.rgb,  clr1*0.5, mask.g*clamp(v_data.z * v_data.z, 0.0, 0.5));
	
	result.a = col.a;

	gl_FragColor = result;

}