#ifdef GL_ES
precision highp float;
#endif

uniform LOWP float uLightPower;
uniform MEDIUMP sampler2D sampler;
uniform MEDIUMP sampler2D sampler1;
varying MEDIUMP vec2 v_texcoord;
varying MEDIUMP vec2 v_texcoord1;

void main()
{
	LOWP vec4 diffuse_color = texture2D(sampler, v_texcoord);

	LOWP vec4 mask = texture2D(sampler1, v_texcoord + vec2(0.0, 0.5));

	LOWP float mask_hull    = mask.r;
	LOWP float mask_glass   = mask.g;
	LOWP float mask_orange  = mask.b;
	LOWP float mask_screw   = step(0.5, mask.a);
	LOWP float mask_lighter = step(0.2, (1.0 - mask.a) * mask.a);
	LOWP float mask_frame   = 1.0 - step(0.03, mask.r + mask.g + mask.b + mask_screw + mask_lighter);

	LOWP vec4 matcap_color_glass  = texture2D(sampler1, vec2(0.0, 0.75) + v_texcoord1 * vec2(0.5, 0.25));
	LOWP vec4 matcap_color_hull   = texture2D(sampler1, vec2(0.0, 0.5) + v_texcoord1 * vec2(0.5, 0.25));
	LOWP vec4 matcap_color_frame  = texture2D(sampler1, vec2(0.5, 0.0) + v_texcoord1 * 0.5);
	LOWP vec4 matcap_color_metall = texture2D(sampler1, vec2(0.5, 0.5) + v_texcoord1 * 0.5);
	LOWP vec4 matcap_color_orange = vec4(matcap_color_glass.a, matcap_color_hull.a, 0.0, 0.0);

	vec3 color_hull = mix(diffuse_color.rgb, vec3(0.7843, 0.3921, 0.0), matcap_color_hull.r)+vec3(1.0, 0.9450, 0.6980)*(matcap_color_hull.g+matcap_color_hull.a)*0.5;


	vec3 color_glass = mix(diffuse_color.rgb,
							 (diffuse_color.rgb*mix(0.6,1.2,matcap_color_glass.r)+matcap_color_glass.ggg),
							 1.0-matcap_color_glass.b);
	vec3 color_orange = mix(diffuse_color.rgb+vec3(1.0, 0.65, 0.35)*(matcap_color_orange.r+matcap_color_glass.g*matcap_color_glass.g), vec3(0.2470, 0.1647, 0.5058), matcap_color_hull.r*2.0);
	vec3 color_screw = mix(diffuse_color.rgb, diffuse_color.rgb*matcap_color_metall.rgb, 0.5*matcap_color_hull.b)+matcap_color_glass.g*vec3(1.0, 0.65, 0.35);
	vec3 color_lighter = mix(color_glass*vec3(0.25,0.4,1)*1.55,diffuse_color.rgb, uLightPower);
	vec3 color_frame = mix(diffuse_color.rgb,matcap_color_frame.rgb,matcap_color_frame.a)+matcap_color_orange.g;

	MEDIUMP vec4 color = vec4(diffuse_color.rgb *
		clamp(1.0 - (mask_hull + mask_glass + mask_orange + mask_screw + mask_lighter + mask_frame), 0.0, 1.0) +
		color_hull * mask_hull +
		color_glass * mask_glass +
		color_orange * mask_orange +
		color_screw * mask_screw +
		color_lighter * mask_lighter +
		color_frame * mask_frame,
		1.0);
	
	gl_FragColor = color;
}