const int MAX_BONES = 80;

attribute vec4 a_vertex;
attribute vec3 a_normal;
attribute MEDIUMP vec2 a_texcoord;
attribute vec4 a_weights;
attribute vec4 a_indices;

uniform mat4 mViewProj;
uniform vec4 mBonesArray[MAX_BONES * 3];

varying MEDIUMP vec2 v_texcoord;
varying MEDIUMP vec2 v_texcoord1;

void main()
{
	int i = int(a_indices.x) * 3;
	HIGHP vec3 p = vec3(dot(mBonesArray[i], a_vertex), dot(mBonesArray[i+1], a_vertex), dot(mBonesArray[i+2], a_vertex)) * a_weights.x;
	
	HIGHP vec4 a_normal_fixed = vec4(a_normal, 0);
	HIGHP vec3 pn = vec3(dot(mBonesArray[i], a_normal_fixed), dot(mBonesArray[i+1], a_normal_fixed), dot(mBonesArray[i+2], a_normal_fixed)) * a_weights.x;
	
	i = int(a_indices.y) * 3;
	p += vec3(dot(mBonesArray[i], a_vertex), dot(mBonesArray[i+1], a_vertex), dot(mBonesArray[i+2], a_vertex)) * a_weights.y;
	pn += vec3(dot(mBonesArray[i], a_normal_fixed), dot(mBonesArray[i+1], a_normal_fixed), dot(mBonesArray[i+2], a_normal_fixed)) * a_weights.y;

	i = int(a_indices.z) * 3;
	p += vec3(dot(mBonesArray[i], a_vertex), dot(mBonesArray[i+1], a_vertex), dot(mBonesArray[i+2], a_vertex)) * a_weights.z;
	pn += vec3(dot(mBonesArray[i], a_normal_fixed), dot(mBonesArray[i+1], a_normal_fixed), dot(mBonesArray[i+2], a_normal_fixed)) * a_weights.z;

	i = int(a_indices.w) * 3;
	p += vec3(dot(mBonesArray[i], a_vertex), dot(mBonesArray[i+1], a_vertex), dot(mBonesArray[i+2], a_vertex)) * a_weights.w;
	pn += vec3(dot(mBonesArray[i], a_normal_fixed), dot(mBonesArray[i+1], a_normal_fixed), dot(mBonesArray[i+2], a_normal_fixed)) * a_weights.w;

	gl_Position = mViewProj * vec4(p, 1.0);

	LOWP vec3 normal = normalize(pn);

	LOWP float u = dot(vec3(1.0, 0.0, 0.0), normal);
	LOWP float v = dot(vec3(0.0, 0.98, -0.194), normal);
	
	v_texcoord = a_texcoord;
	v_texcoord1 = vec2((u + 1.0), (v + 1.0)) * 0.5;
}
