#ifdef GL_ES
precision highp float;
#endif

uniform MEDIUMP sampler2D sampler;
varying MEDIUMP vec2 v_texcoord;
varying MEDIUMP vec4 v_texcoord1;

void main()
{
	LOWP vec3 diffuse_color = texture2D(sampler, v_texcoord).rgb;
	LOWP vec3 mask = texture2D(sampler, vec2(0.75, 1.0 - 0.75) + v_texcoord * 0.5).rgb;
	LOWP vec3 mcap1 = texture2D(sampler, vec2(0.75, 0.625) + v_texcoord1.xy * 0.125).rgb;
	LOWP vec3 mcap2 = texture2D(sampler, vec2(0.8875,0.6375) + v_texcoord1.zw * 0.1).rgb;
	LOWP vec3 mcap3 = texture2D(sampler, vec2(0.875, 1.0 - 0.625) + v_texcoord * 0.25).rgb;
	
	MEDIUMP float sss = (mcap3.b + mcap1.b) * mcap2.r;
	vec3 body_color = diffuse_color + vec3(0.345, 0.223, 0.066) * sss + mcap1.r * 0.35;
	vec3 shell_color = diffuse_color + diffuse_color * mcap1.g + mcap1.r * 0.15;

	gl_FragColor = vec4(mix(diffuse_color + step(0.28, mcap1.g * mask.b),
					   mix(body_color, shell_color, mask.g) * (1.0 - mask.r * 1.0/*u_hatShadow*/),
					   1.0 - mask.b), 1.0);
}