#ifdef GL_ES
precision highp float;
#ifndef LOWP
#define LOWP lowp
#define MEDIUMP mediump
#endif
#endif


varying MEDIUMP vec3 v_texcoord_lineT;
varying LOWP vec3 v_amp_highl_alpha;

uniform LOWP sampler2D sampler;
#if defined(ENGINE_OS_ANDROID)
	uniform LOWP sampler2D sampler1;
	uniform int CombinedTexture;
#endif

void main(void)
{
	gl_FragColor = texture2D(sampler, v_texcoord_lineT.xy);
#if defined(ENGINE_OS_ANDROID)
	if (CombinedTexture == 1) {
		gl_FragColor.a = texture2D(sampler1, v_texcoord_lineT.xy).r;
	}
#endif

	gl_FragColor.rgb += clamp(abs(v_texcoord_lineT.z)*-32.0 + 4.0, 0.0, 1.0) * v_amp_highl_alpha.r;
	gl_FragColor *= v_amp_highl_alpha.gggb;
}