#ifdef GL_ES
precision highp float;
#endif

uniform LOWP sampler2D sampler;
#if defined(ENGINE_OS_ANDROID)
	uniform LOWP sampler2D sampler1;
	uniform int CombinedTexture;
#endif

uniform LOWP sampler2D sampler2;
uniform vec2 uv_size;
varying vec2 v_texcoord;
varying vec2 v_texcoord1;
varying LOWP vec4 v_color;

const float ABS_OFFSET = 0.12;

void main(void)
{
	LOWP vec4 distortPx = texture2D(sampler2, v_texcoord1);
	LOWP vec4 offsetColor;
		
	vec3 normal;
	normal = 2.0 * distortPx.rgb - 1.0;
	normal = normalize(normal);
	normal *= ABS_OFFSET * distortPx.a;
	
	vec2 offsetPos = v_texcoord + uv_size * normal.xy;
	offsetColor = texture2D(sampler, offsetPos);
#if defined(ENGINE_OS_ANDROID)
	if (CombinedTexture == 1){
		offsetColor.a = texture2D(sampler1, offsetPos).r ;
	}
#endif
	
	gl_FragColor = offsetColor;
	gl_FragColor.a *= v_color.a;
}