#ifdef GL_ES
precision highp float;
#endif

uniform LOWP vec3 u_fogColor;
varying float v_density;

uniform LOWP sampler2D sampler;
uniform LOWP sampler2D sampler1;
uniform LOWP sampler2D sampler2;
uniform LOWP float u_blend1;
uniform LOWP float u_blend2;
varying LOWP vec4 v_color;
varying MEDIUMP vec2 v_texcoord;  // размер текстуры 256х256

void main()
{
	LOWP vec4 color1 = texture2D(sampler, v_texcoord);
	LOWP vec4 color2 = texture2D(sampler1, v_texcoord);
	LOWP vec4 color3 = texture2D(sampler2, v_texcoord);

	LOWP vec4 color = v_color * mix(color1, color2, u_blend1);
	color = v_color * mix(color, color3, u_blend2);
	
	color.rgb -= (color.rgb - u_fogColor) * v_density;
	gl_FragColor = color;
}
