#ifdef GL_ES
precision highp float;
#endif

uniform LOWP sampler2D sampler;
uniform vec4 uvs;
varying vec2 v_texcoord;

void main(void)
{
	float w = uvs.y - uvs.x;
	float h = uvs.w - uvs.z;
	
	vec2 tx;
	tx.x = (v_texcoord.x - uvs.x) / w;
	tx.y = (v_texcoord.y - uvs.z) / h;
	
	vec4 basePx = texture2D(sampler, v_texcoord);
	vec4 addPx = basePx;
	
	float r = distance(tx, vec2(0.5,0.5));//sqrt((tx.x - 0.5)*(tx.x - 0.5) + (tx.y - 0.5)*(tx.y - 0.5));

	addPx.a = tx.x;//(r/0.5)*0.3;
	addPx.rgb *= addPx.a;
	
	gl_FragColor.a = basePx.a;
	gl_FragColor.rgb = basePx.rgb + addPx.rgb;
}