#ifdef GL_ES
precision highp float;
#endif

uniform LOWP sampler2D sampler;

varying MEDIUMP vec2 v_texcoord; 
varying MEDIUMP vec2 v_capcoord;

uniform float p;

void main()
{
	vec4 diffuse_color = texture2D(sampler, v_texcoord);
	vec4 matcap1_color = texture2D(sampler, v_capcoord * 0.25);
	vec4 matcap2_color = texture2D(sampler, v_capcoord * 0.25 + vec2(0.25, 0.0));
	
	//vec2 mask_uv = (v_texcoord * 0.125) + vec2(0.125, 0.25); 
	//float mask_color = texture2D(sampler, mask_uv).r;
	//gl_FragColor = diffuse_color + matcap1_color * (1.0 - mask_color) + matcap2_color * mask_color;
	
	vec4 subcolor = mix(vec4(0.5, 0.5, 1.0, 1.0), vec4(1.0), p);
	
	gl_FragColor =  diffuse_color * subcolor
					+ matcap1_color * p
					+ matcap2_color;
}


