#ifdef GL_ES
precision highp float;
#endif



varying vec2 v_texcoord;
varying float p;

uniform LOWP sampler2D sampler;


#if defined(ENGINE_OS_ANDROID)
	uniform LOWP sampler2D sampler1;
	uniform int CombinedTexture;
#endif

void main(void)
{
	vec4 basePx = texture2D(sampler, v_texcoord);
		
#if defined(ENGINE_OS_ANDROID)
	if (CombinedTexture == 1){
		basePx.a = texture2D(sampler1, v_texcoord).r;
	}
#endif
	float contract = step(basePx.r, p);
	
	gl_FragColor.rgb = vec3(1.0);
	gl_FragColor.a = basePx.a * basePx.g * contract;
}