#ifdef GL_ES
precision highp float;
#endif

uniform LOWP sampler2D sampler;
uniform LOWP vec4 mColor;
uniform vec3 mLight;

varying vec3 v_normal;
varying vec2 v_texcoord;

void main()
{
	vec3 normal = normalize(v_normal);
	float nl = dot(-mLight, normal);
	nl = clamp((nl+1.0) * 0.5 * 0.3, 0.0, 1.0);
	LOWP float lc = clamp(nl + 0.7, 0.0, 1.0);
	gl_FragColor =  texture2D(sampler, v_texcoord) * vec4(lc, lc, lc, 1.0) * mColor;
}
