const int MAX_BONES = 80;

attribute vec4 a_vertex;
attribute vec2 a_texcoord;
attribute vec4 a_weights;
attribute vec4 a_indices;
attribute vec3 a_normal;

uniform mat4 mViewProj;
uniform vec4 mBonesArray[MAX_BONES*3];

varying vec2 v_texcoord;
varying vec3 v_normal;

void main()
{
	int i = int(a_indices.x) * 3;
	vec3 p = vec3(dot(mBonesArray[i], a_vertex), dot(mBonesArray[i+1], a_vertex), dot(mBonesArray[i+2], a_vertex)) * a_weights.x;
	vec3 n = vec3(dot(mBonesArray[i].xyz, a_normal), dot(mBonesArray[i+1].xyz, a_normal), dot(mBonesArray[i+2].xyz, a_normal)) * a_weights.x;

	i = int(a_indices.y) * 3;
	p += vec3(dot(mBonesArray[i], a_vertex), dot(mBonesArray[i+1], a_vertex), dot(mBonesArray[i+2], a_vertex)) * a_weights.y;
	n += vec3(dot(mBonesArray[i].xyz, a_normal), dot(mBonesArray[i+1].xyz, a_normal), dot(mBonesArray[i+2].xyz, a_normal)) * a_weights.y;

	i = int(a_indices.z) * 3;
	p += vec3(dot(mBonesArray[i], a_vertex), dot(mBonesArray[i+1], a_vertex), dot(mBonesArray[i+2], a_vertex)) * a_weights.z;
	n += vec3(dot(mBonesArray[i].xyz, a_normal), dot(mBonesArray[i+1].xyz, a_normal), dot(mBonesArray[i+2].xyz, a_normal)) * a_weights.z;

	i = int(a_indices.w) * 3;
	p += vec3(dot(mBonesArray[i], a_vertex), dot(mBonesArray[i+1], a_vertex), dot(mBonesArray[i+2], a_vertex)) * a_weights.w;
	n += vec3(dot(mBonesArray[i].xyz, a_normal), dot(mBonesArray[i+1].xyz, a_normal), dot(mBonesArray[i+2].xyz, a_normal)) * a_weights.w;

	gl_Position = mViewProj * vec4(p, 1.0);
	v_normal = normalize(mViewProj * vec4(n, 0.0)).xyz;
	v_texcoord  = a_texcoord;
}
