attribute vec4 a_vertex;       // позиция и модификатор ширины 
attribute vec2 a_texcoord;     // uv координаты для текстуры молнии. u1 координата также является дистанцией от начала молнии, для синусоидальных колебаний
attribute vec2 a_texcoord1;    // нормаль молнии. используется для восстановления геометрии и для синусоидальных волн. это скорее нормаль фигуры, а не треугольника или вершины
attribute vec2 a_texcoord2;    // дополнительные параметры. x - модификатор амплитуды синуса, y - прозрачность молнии в данной точке
attribute LOWP vec4 a_color;

uniform mat4 u_modelview;
uniform float u_time;
uniform float u_amplitude;
uniform float u_length;
uniform float u_width;         // половина ширины треугольника

varying vec2 v_texcoord;
varying float v_alpha;

void main()
{
	vec4 pos = vec4(a_vertex.xy, 0.0, 1.0);
	pos.xy += a_vertex.z * a_texcoord1 * u_width;	// растягиваем изначально схлопнутую геометрию
	pos.xy += a_texcoord2.x * a_texcoord1 * u_amplitude * sin(u_length * a_texcoord.x + u_time);    // синусоидальная волна

	v_texcoord = a_texcoord.yx;
	v_alpha = a_texcoord2.y;

	gl_Position = u_modelview * pos;
}
