#ifdef GL_ES
precision highp float;
#endif

uniform LOWP sampler2D sampler;
uniform LOWP sampler2D sampler1;
uniform float u_alpha;
uniform float u_distortion;

varying MEDIUMP vec2 v_texcoord;

void main(void)
{
	LOWP vec4 distortPx = texture2D(sampler1, v_texcoord);
	LOWP vec4 offsetColor;
	vec2 offsetPos = v_texcoord;
	
	vec3 normal;
	normal = 2.0 * distortPx.rgb - 1.0;
	normal = normalize(normal);
	normal *= u_distortion * distortPx.a;
	
	offsetPos = v_texcoord + normal.xy;
	offsetColor = texture2D(sampler, offsetPos);
	offsetColor.a *= u_alpha;
	offsetColor.rgb *= 1.0 + offsetColor.a;
	
	gl_FragColor = offsetColor;
}