#ifdef GL_ES
	precision highp float;
#endif

uniform mat4 u_view;

uniform LOWP sampler2D sampler;
uniform LOWP sampler2D sampler1;
uniform LOWP sampler2D sampler2;
uniform LOWP sampler2D sampler3;
varying LOWP vec4 v_color;
varying vec2 v_texcoord;
varying vec2 v_texcoord1;

uniform LOWP vec3 u_fogColor;
varying float v_density;

void main()
{
	LOWP vec4 diffuse_color = texture2D(sampler, v_texcoord1);
	LOWP vec4 matcap_color = mix(texture2D(sampler2, v_texcoord), texture2D(sampler3, v_texcoord),
		texture2D(sampler1, v_texcoord1).r);

	LOWP vec4 color = diffuse_color + matcap_color;
	color.rgb -= 0.5 * (color.rgb - u_fogColor) * v_density;

    gl_FragColor = color;
}
