#ifdef GL_ES
	precision highp float;
#endif

attribute vec4 a_vertex;
attribute vec3 a_normal;
attribute vec2 a_texcoord;
attribute LOWP vec4 a_color;

uniform vec4 u_lightPos;
uniform vec4 u_pos;
uniform vec2 u_fogBorder;
varying float v_density;

uniform mat4 u_modelview;
uniform mat4 u_view;

varying LOWP vec4 v_color;
varying vec2 v_texcoord;
varying vec2 v_texcoord1;

void main()
{
	gl_Position = u_modelview * a_vertex;
	
	LOWP vec3 normal = normalize(mat3(u_view) * a_normal);

    LOWP float u = dot(vec3(0.0, 0.98, -0.194), normal);
    LOWP float v = dot(vec3(1.0, 0.0, 0.0), normal);

	v_texcoord = vec2((v + 1.0), (u + 1.0)) * 0.5;
	v_texcoord1 = a_texcoord;
	v_color = vec4(1.0);

	// туман
	vec4 P = u_view * a_vertex;
	vec3 N = normalize(u_view * vec4(a_normal, 0.0)).xyz;
	vec3 V = -normalize(P.xyz);
	vec3 G = normalize(2.0 * dot(N, V) * N - V);
	float f = 0.5 - dot(V, N);
	f = 1.0 - 4.0 * f * f;

	float d = length(u_pos - u_lightPos);
	f = (u_fogBorder.y - d) / (u_fogBorder.y - u_fogBorder.x);
	v_density = (1.0 - clamp(f, 0.0, 1.0)) / 1.3;
}
