#ifdef GL_ES
	precision highp float;
#endif

attribute vec4 a_vertex;
attribute vec3 a_normal;
attribute vec2 a_texcoord;

uniform mat4 u_modelview;
uniform mat4 u_view;

varying vec2 v_texcoord;
varying vec2 v_texcoord1;

void main()
{
	vec3 Up = vec3(0.0, 1.0, 0.0);
	vec3 Right = vec3(1.0, 0.0, 0.0);
	vec3 Normal = normalize(mat3(u_view) * a_normal);
	
	float u = dot(Up, Normal);
	float v = dot(Right, Normal);
	
	v_texcoord = a_texcoord;
	v_texcoord1 = vec2(v + 1.0, u + 1.0) * 0.5;
	
	gl_Position = u_modelview * a_vertex;
}