#ifdef GL_ES
precision highp float;
#endif

uniform LOWP sampler2D sampler;
#if defined(ENGINE_OS_ANDROID)
	uniform LOWP sampler2D sampler1;
	uniform int CombinedTexture;
#endif
uniform LOWP sampler2D sampler2;
uniform LOWP sampler2D sampler3;
uniform float y;
uniform float scale_y;
uniform float intensety_wave;
uniform float intensety_puzzle;
varying vec2 v_texcoord;
varying LOWP vec4 v_color;

void main()
{
	gl_FragColor = v_color * texture2D(sampler, v_texcoord);
	
#if defined(ENGINE_OS_ANDROID)
	if (CombinedTexture == 1) {
		gl_FragColor.a = v_color.a * texture2D(sampler1, v_texcoord).r;
	}
#endif

	vec4 puzzle_glow = texture2D(sampler3, v_texcoord);
	vec4 wave_glow = texture2D(sampler2, vec2(v_texcoord.x, v_texcoord.y / scale_y - y));
	float wave_avg = (wave_glow.r + wave_glow.g + wave_glow.b) / 3.0;
	gl_FragColor.rgb += wave_glow.rgb * intensety_wave + puzzle_glow.rgb * wave_avg * intensety_puzzle;
}
