#ifdef GL_ES
precision highp float;
#endif

uniform LOWP sampler2D sampler;
uniform LOWP sampler2D sampler1;
uniform LOWP sampler2D sampler2;
uniform LOWP vec4 u_waterColor;
uniform MEDIUMP float u_intensity;

varying vec3 v_texcoord;
varying LOWP vec4 v_color;
varying float v_time;
varying vec4 v_waterCoords;
varying vec2 v_backCoords;

void main()
{
	// черно-белая маска для поверхности
	MEDIUMP float mask = texture2D(sampler1, v_texcoord.xy).r * 2.0;
	
	LOWP vec4 backgroundMask = texture2D(sampler2, v_backCoords);
	mask *= 1.0 - backgroundMask.a;
	
	// вертикальные волны на поверхности. для оптимизации надо разбить сетку спрайта и вынести это 
	// в вертексный шейдер
	float vertShift = sin(v_texcoord.z + v_time) * 0.012;

	// две выборки из текстуры со смещением текстурных координат
	LOWP vec2 col0 = texture2D(sampler, v_waterCoords.xy + vec2(0.0, vertShift)).rg;
	LOWP vec2 col1 = texture2D(sampler, v_waterCoords.zw - vec2(0.0, 0.5 - vertShift)).rg;

	// берем среднее значение
	// сейчас к текстуре дополнительно применяется цвет - опять же упростим на уровне текстуры
	MEDIUMP float wave = (col0.r + col1.r) * 0.025 * u_intensity;
	MEDIUMP vec4 col = vec4(wave, wave, wave, mask);
	
	//overbrights
	MEDIUMP float light = min(0.02, pow(col0.g * col1.g, 5.0) * 25.0);
	col.rgb += light * u_intensity;
	
	// применение цвета аквариума
	col *= u_waterColor;

	// в коде выставлен мод Add, для получения BlendOp SrcAlpha One умножаем цвет на alpha
	col *= col.a;
	
	gl_FragColor = col;//vec4(backgroundMask.a, backgroundMask.a, backgroundMask.a, 1.0);
}
