attribute vec4 a_vertex;
attribute vec2 a_texcoord;
attribute vec2 a_texcoord1;
attribute LOWP vec4 a_color;

uniform mat4 u_modelview;
uniform float u_time;

varying vec3 v_texcoord;
varying LOWP vec4 v_color;
varying float v_time;

varying vec4 v_waterCoords;
varying vec2 v_backCoords;

void main()
{
	v_color = a_color;
	
	// чистые координаты используются для маски водной поверхности
	v_texcoord.xy = a_texcoord;
	// используется для вертикальных волнб 10.0 - длина волны
	v_texcoord.z = a_texcoord.x * 10.0;
	
	v_backCoords = a_texcoord1;
	
	// используется для вертикальных волн, 3.75 - скорость движения волны, фазы синуса
	v_time = u_time * 2.5;
	
	// скорость мелкого волнения , 0.03 подобран
	float shiftTime = fract(u_time * 0.03);

	// растягивает воду по горизонтали, т.к. смотрим на водную поверхность под углом, 0.667 - подобранный коэффиециент
	MEDIUMP float waterXCoord = a_texcoord.x * 0.667;
	
	v_waterCoords.xy = vec2(waterXCoord + shiftTime, a_texcoord.y + shiftTime);
	v_waterCoords.zw = vec2(waterXCoord - shiftTime, a_texcoord.y - shiftTime);

	gl_Position = u_modelview * a_vertex;
}
