#ifdef GL_ES
precision highp float;
#endif

uniform LOWP sampler2D sampler;
uniform vec4 xyAF;
uniform float OffsetNNN;

varying vec2 v_texcoord;
varying vec2 v_texcoord1;

void main()
{
	vec2 distanceVector = v_texcoord1 - xyAF.xy;
	float distance = length(distanceVector);
	distanceVector /= distance;
	float diff = distance - OffsetNNN;
	float amplitude = xyAF.z * (1.0/0.03) * exp(-diff * diff / xyAF.w);

	vec2 waveVector = distanceVector * amplitude;
	gl_FragColor = vec4(waveVector.x+0.5, waveVector.y+0.5, 0.5, amplitude);
}
