attribute vec4 a_vertex;
attribute vec2 a_texcoord;
attribute LOWP vec4 a_color;

uniform mat4 u_modelview;
uniform float u_time;			// умножается на 4.0 в коде, скорость фазы - скорость волны

varying vec2 v_texcoord;

void main()
{
	vec4 pos = u_modelview * a_vertex;

	// 1) 512.0 * 0.05 = 25.6; 512 - маппинг экранных координат в длину волны; 0.05 - подобранный множитель
	v_texcoord = a_texcoord + sin(pos.x * 25.6 + u_time) * 0.001 * a_color.r;

	gl_Position = pos;
}
