#ifdef GL_ES
precision highp float;
#endif

uniform LOWP vec3 u_fogColor;
varying float v_density;

uniform LOWP samplerCube sampler;
uniform LOWP sampler2D sampler1;
varying LOWP vec4 v_color;
varying vec2 v_texcoord;
varying vec3 v_texcoord1;
varying vec3 v_texcoord2;

void main()
{
	LOWP vec3 reflection = textureCube(sampler, v_texcoord1).rgb * clamp(v_texcoord2, 0.0, 1.0);
	LOWP vec4 color = v_color * texture2D(sampler1, v_texcoord) + vec4(0.25 * reflection, 1.0);
	color.rgb -= 0.5 * (color.rgb - u_fogColor) * v_density;
	gl_FragColor = color;
}
