attribute vec4 a_vertex;
attribute vec3 a_normal;
attribute vec2 a_texcoord;

uniform mat4 u_modelview;
uniform mat4 u_view;
uniform vec4 u_lightPos;
uniform vec4 u_pos;
uniform vec2 u_fogBorder;

varying float v_density;

varying LOWP vec4 v_color;
varying vec2 v_texcoord;
varying vec3 v_texcoord1;
varying vec3 v_texcoord2;

void main()
{
	vec4 P = u_view * a_vertex;
	vec3 N = normalize(u_view * vec4(a_normal, 0.0)).xyz;
	vec3 V = -normalize(P.xyz);
	vec3 G = normalize(2.0 * dot(N, V) * N - V);
	float f = 0.5 - dot(V, N);
	f = 1.0 - 4.0 * f * f;

	gl_Position = u_modelview * a_vertex;
	v_texcoord = a_texcoord;
	v_texcoord1 = vec3(-G.x, G.y, -G.z);
	v_texcoord2 = vec3(f);
	
	float d = length(u_pos - u_lightPos);
	f = (u_fogBorder.y - d) / (u_fogBorder.y - u_fogBorder.x);
	v_density = (1.0 - clamp(f, 0.0, 1.0)) / 1.3;

	v_color = vec4(1.0);
}
